# mips-sony-news.make

# Part one:

     INSTALL = cp
        MAKE = gmake
      RANLIB = ranlib
     ARFLAGS = cvr
          CC = gcc
        SHLD = 
   SHLDFLAGS = 
    SHCFLAGS = 

# Part two:

     DEFINES = -DOS_HAS_PROTOTYPES \
               -DOS_NEEDS_BCOPY \
               -DOS_HAS_SIGNALS -DOS_HAS_SYS_WAIT_H -DOS_HAS_WAIT3 \
               -DOS_HAS_SYSFILE_H \
               -DOS_MACHINE_TYPE="\"sony\"" -DOS_SYSTEM_TYPE="\"news\"" 

# Part two:
# ---------
# Machine/System specific flags:
#
# A. Compiler flags:
# ------------------
# REGISTER (default 'register'):
#    Prefix keyword for local declaration, to make the local allocated
#    in a register.
# VOLATILE (default 'volatile'):
#    Prefix keyword for local declaration, to make them volatile.
# INLINE (default 'inline'):
#    Prefix keyword for functions to be inlined by the compiler. This
#    should really be set if it is possible.
# OS_STACK_GROWS (default 'OS_STACK_DOWN'):
#    The C stack growth direction. This can be either OS_STACK_DOWN,
#    or OS_STACK_UP.
# OS_HAS_PROTOTYPES (default undefine):
#    If your compiler supports ANSI prototype declarations.
#
# B. System flags:
# ----------------
#
# OS_PATH_SEPARATOR (default '/'):
#    The character to be used in file path names (eg '\' for dos)
# OS_PATH_HOME (default '~'):
#    The character to be used to express a home directory in a
#    path. Define this to '\0' if your system doesn't support
#    multiple users.
# OS_DEFAULT_PATH (default "~/oscheme:/usr/local/lib/oscheme"
#    Default oscheme load path (this can be overwritten either through OS_PATH
#    env variable, or wit hthe -path option.)
# OS_DEFAULT_EXTENSION (default ":.scm")
#    Default oscheme load extension (can be overwritten eith through 
#    OS_EXTENSION, or with -ext option.)
# OS_NEEDS_BCOPY (default undefine):
#    If your environment doesn't provide the bcopy functions, this
#    defines enable the use of memcpy instead.
# OS_HAS_SIGNALS (default undefine):
#    If your OS supports signals. In this case, you have the additional 
#    defines:
#        OS_REDECLARE_SIGNALS (default undefine): 
#            if signals should be restarted
#        OS_SIGNALS_MAX_PENDING (default 32): 
#            max # of pending signals
# OS_HAS_GETWD (default undefine):
#    If your system only provide this (broken) version of getcwd
# OS_HAS_RLIMIT (default undefine):
#    If your system supports the {set/get}rlimit calls (otherwise, the BSD
# OS_HAS_FORK (default undefine)
#    If your system doesn't provide the vfork (which is the default)
#    getdtablesize is used).
# OS_HAS_STRING_H (default undefine):
#    If <string.h> is to be used instead of <strings.h>
# OS_HAS_UNISTD_H (default undefine):
#    If your system have an unistd.h include file (for access(2))
# OS_HAS_SYSFILE_H (default undefine):
#    If your system requires sys/file.h to define F_OK
# OS_HAS_SYSDIR_H (default undefine):
#    If your system uses sys/dir.h instead of dirent.h
# OS_HAS_SYS_WAIT_H
#    If your system needs sys/wait.h to provide wait (2) facility. In this last
#    case, you might also define:
#        OS_HAS_WAIT3: in which case wait3 will be used whenever possible.
# OS_HAS_SYS_SELECT_H
#    If sys/select.h needs to be included to get select(2) definitions.
# OS_REGWIN_SIZE (default undefine):
#    Size of window register (# of rec calls, before copying the stack). On
#    sparc, defining this to 256 will be ok (too much secure !)
# OS_FLUSH_REGWIN_CODE (default undefine):
#    Define this symbol to the code to be emitted to flush register 
#    window. On sparc, for example: '-DOS_FLUSH_REGWIN_CODE=asm("t 0x3")'
# OS_HAS_DLD (default undefine):
#    This will a few subrs (see *dld.c), which allows to dynamically load in
#    object files.

# Part three:
# -----------

OPTIONAL_SOURCES =
OPTIONAL_OBJECTS = 

# Part four:
# ----------
# Path customization

# Gc customization:
# Absolute path needed here ! Use bigloo for that but build gc.a first:
#    cd /usr/local/src/bigloo1.7/runtime1.7/.Olib/Gc
#    ar cvr gc.a *.o ; ar ts gc.a

      GC_DIR = /net/koala/packages/gc/current/sony
 GC_INCLUDES = -I$(GC_DIR)
      GC_LIB = $(GC_DIR)/gc.a

# Dld customization 
# Absolute path needed here !

#     DLD_DIR = 
#DLD_INCLUDES = -I$(DLD_DIR)
#     DLD_LIB = -L$(DLD_DIR)

# Part five:

     OS_PREFIX = /net/koala/packages/oscheme
     OS_BINDIR = $(OS_PREFIX)/mips-sony-news/bin
  OS_MODULEDIR = $(OS_PREFIX)/mips-sony-news/modules
     OS_LIBDIR = $(OS_PREFIX)/lib
    OS_HTMLDIR = $(OS_PREFIX)/lib/html
 OS_SCRIPTSDIR = $(OS_PREFIX)/lib/scripts

