;; JJ Girardot

;; Permutations
    
(define (except i l)
   (if (<= i 0)
       (cdr l)
       (cons (car l)
             (except (- i 1) (cdr l)))))

(define (prefix-all v l)
   (if (null? l)
       '()
       (cons (cons v (car l))
             (prefix-all v (cdr l)))))
             
(define (loop i l r)
  (if (>= i (length l))
      r
      (loop (+ i 1) l
         (append r
            (prefix-all (list-ref l i)
               (perm (except i l)))))))

(define (perm l)
   (if (>= 1 (length l))
       (list l)
       (loop 0 l '())))