;;***************************************************************************
;; fib.scm
;; fib.scm,v 1.1.1.1 1995/02/27 15:16:06 baird Exp
;; See the file COPYRIGHT foe licensing conditions.
;;***************************************************************************

(define (fib n)
  (if (< n 2) 1 (+ (fib (- n 1)) (fib (- n 2)))))

(define make-onum
  (letrec ((onum [obj:root clone])
         (*zer* [onum clone])		;; how about this :-)
         (*one* [onum clone])		;; really fancy !
         (*two* [onum clone]))		;; same for this one !
    [onum defineSlot: "int" init: 1]
    (define-message onum (new: n)
      (cond ((= n 0) *zer*)
            ((= n 1) *one*)
            ((= n 2) *two*)
            (else (let ((new [self clone])) [new int: n] new))))
    (define-message onum (add: n)
      [self new: (+ [self int] [n int])])
    (define-message onum (minus: n)
      [self new: (- [self int] [n int])])
    (define-message onum (display)
      (format (current-output-port) "#[onum %0]" [self int])
      (output-port-flush))
    ;; the normal 'fib:
    (define-message onum (fib)
      [[[self minus: *one*] fib] add: [[self minus: *two*] fib]])
    ;; fib for one and two
    [*one* int: 1] (define-message *one* (fib) *one*)
    [*two* int: 2] (define-message *two* (fib) *two*)
    [*zer* int: 0] (define-message *zer* (fib) *zer*)
    (lambda (i) [onum new: i])) )
