/***************************************************************************
 * os_struct.h
 * os_struct.h,v 1.1.1.1 1995/02/27 15:15:42 baird Exp
 * See the file COPYRIGHT for licensing conditions.
 ***************************************************************************/

#ifndef OS_EOBJ_STRUCT_H_
#define OS_EOBJ_STRUCT_H_

/*
 * Prototypes (only !)
 */

OsEObj OsStructClassMake OS_P ((char *name, unsigned int size)) ;
OsEObj OsStructMake OS_P ((OsEObj sclass, OsPointer pointer)) ;

void   OsStructRWSlotDeclare OS_P ((OsEObj sclass
                                    , char *name
                                    , OsObject (*cfun)()
                                    , unsigned int offset
                                    , void *data)) ;
void   OsStructRSlotDeclare OS_P ((OsEObj sclass
                                   , char *name
                                   , OsObject (*cfun)()
                                   , unsigned int offset
                                   , void *data)) ;
void   OsStructWSlotDeclare OS_P ((OsEObj sclass
                                   , char *name
                                   , OsObject (*cfun)()
                                   , unsigned int offset
                                   , void *data)) ;

OsObject OsStructAccessorChar OS_P ((char *loc
                                     , OsChar value
                                     , void *u1, void *u2)) ;
OsObject OsStructAccessorShort OS_P ((short *loc
                                      , OsInteger value
                                      , void *u1, void *u2)) ;
OsObject OsStructAccessorUnsignedShort OS_P ((unsigned short *loc
                                              , OsInteger value
                                              , void *u1, void *u2)) ;
OsObject OsStructAccessorInt OS_P ((int *loc
                                    , OsInteger value
                                    , void *u1, void *u2)) ;
OsObject OsStructAccessorLong OS_P ((long *loc
                                     , OsInteger value
                                     , void *u1, void *u2)) ;
OsObject OsStructAccessorString OS_P ((char **loc
                                       , OsString value
                                       , void *u1, void *u2)) ;
OsObject OsStructAccessorObject OS_P ((OsObject *loc
                                       , OsObject value
                                       , void *u1, void *u2)) ;

OsObject (*OsStructAccessorFind OS_P ((unsigned int size, int sign)))() ;

void *OsStructCPointer OS_P ((OsEObj struct_obj)) ;

void OsEObjStructInitialize OS_P ((OsInterp interp, int *parcg, char **argv)) ;

/*
 * Macros:
 */

#define OsOffsetOf(_t,_f)	OsOffset(_t*,_f)
#define OsOffset(_pt,_f)	((unsigned int) &(((_pt) NULL)->_f))

#define OsFieldSize(_t,_f)	sizeof (((_t *) 0)->_f)

#endif /* OS_EOBJ_STRUCT_H_ */
