/*
 * Definitions etc. for regexp(3) routines.
 *
 * Caveat:  this is V8 regexp(3) [actually, a reimplementation thereof],
 * not the System V one.
 */

#ifndef _OL_REGEXP_H_
#define _OL_REGEXP_H_

#define NSUBEXP  10
typedef struct _os_regexp {	/* ABS: add os_ prefix */
	char *startp[NSUBEXP];
	char *endp[NSUBEXP];
	char regstart;		/* Internal use only. */
	char reganch;		/* Internal use only. */
	char *regmust;		/* Internal use only. */
	int regmlen;		/* Internal use only. */
	char program[1];	/* Unwarranted chumminess with compiler. */
} os_regexp;			/* ABS: added os_ prefix */

extern os_regexp *os_regcomp();
extern int os_regexec();
extern void os_regerror();

/* ABS included regmagic.h */
#define	OL_MAGIC	0234

/*
 * (ABS) : needed for os_regsub
 * Utility definitions.
 */
#ifndef CHARBITS
#define	UCHARAT(p)	((int)*(unsigned char *)(p))
#else
#define	UCHARAT(p)	((int)*(p)&CHARBITS)
#endif

#endif /* _OL_REGEXP_H_ */
    
