# Compiling oscheme on i386, linux. Part number refers to template.make.
# Part one:

     INSTALL = cp
      RANLIB = ranlib
        MAKE = make
     ARFLAGS = clq
        SHCC = ld
   SHLDFLAGS = -r
    SHCFLAGS = 
          CC = gcc

# Part two:

     DEFINES = -DOS_HAS_SIGNALS -DOS_REDECLARE_SIGNALS \
               -DOS_HAS_STRING_H -DOS_HAS_UNISTD_H \
               -DOS_HAS_PROTOTYPES \
               -DOS_HAS_SYS_WAIT_H -DOS_HAS_WAIT3 \
               -DOS_MACHINE_TYPE="\"ix86\"" -DOS_SYSTEM_TYPE="\"linux\"" 

# Part three:
# WARNING: using dld under oscheme/linux, requires two patches:
#  1. Patch Boehm's GC to increase the MAX_ROOT_SETS define (in mark_rts.c).
#     This is because we add_roots after each dynamically loaded "file", for
#     example, the w3 interface adds root for each file of the libwww (!)
#     Setting this define to 128 seems to be sufficient.
#  2. Patch to the dld package in order to declare static/bss data to GC.
#     Add the following lines at the end of the read_text_and_data function.
# /* ABS patch start here, to declare dyn libraries to Boehm's GC */
# #ifdef DLD_USES_GC
#     {
#         char *start ;
#         start = ((char *) entry->text_start_address) + entry->header.a_text ;
#         GC_add_roots (start, start+entry->header.a_data+entry->header.a_bss);
#     }
# #endif /* DLD_USES_GCC */
# If you have made all these changes, then you can safely uncomment the 
# following two line, add -DOS_HAS_DLD in DEFINES, and use 'dynamic' instead
# of 'lib' in build-list.

# OPTIONAL_SOURCES = gdld.c
# OPTIONAL_OBJECTS = gdld.o

# Part four:
# Absolute path needed here !
# On linux kernels <= 1.0.9, use gc4.2, *not* gc4.3 (strange bug, probably in
# the kernel)

      GC_DIR = /net/koala/packages/gc/current/linux
 GC_INCLUDES = -I$(GC_DIR)
      GC_LIB = $(GC_DIR)/gc.a

# Dld customization 
# Absolute path needed here !

#      DLD_DIR = /net/koala/packages/dld/current/linux
# DLD_INCLUDES = -I$(DLD_DIR)
#      DLD_LIB = -L$(DLD_DIR) -ldld

# Part five:
# ----------
# Installation parameters:

# Part five:

     OS_PREFIX = /net/koala/packages/oscheme
     OS_BINDIR = $(OS_PREFIX)/i386-unknown-linux/bin
  OS_MODULEDIR = $(OS_PREFIX)/i386-unknown-linux/modules
     OS_LIBDIR = $(OS_PREFIX)/lib
    OS_HTMLDIR = $(OS_PREFIX)/lib/html
 OS_SCRIPTSDIR = $(OS_PREFIX)/lib/scripts

