/***************************************************************************
 * os_regexp.h
 * os_regexp.h,v 1.1.1.1 1995/02/27 15:15:51 baird Exp
 * See the file COPYRIGHT for licensing conditions.
 ***************************************************************************/

#ifndef _OS_REGEXP_H_
#define _OS_REGEXP_H_

#include "regexp.h"

extern OsClass OsRegexpClass ;

#define OsIsRegexp(r)	  (((OsObject) (r))->os_class == OsRegexpClass)
#define OsMustBeRegexp(r) (OsMustBeOfClass((r), OsRegexpClass))
#define OsShouldBeRegexp(r) \
     ((r) = (OsRegexp) OsMustBeOfClass((r), OsRegexpClass))

typedef struct _OsRegexp {
    OsClass   os_class ;
    OsString  source ;
    os_regexp *prog ;
} OsRegexpRec, *OsRegexp ;

/*
 * Exteranls:
 */

OsRegexp OsRegexpMake OS_P ((unsigned char *source)) ;
OsRegexp OsRegexpMakeWithString OS_P ((OsString source)) ;
    
void OsRegexpInitialize OS_P ((OsInterp interp, int *pargc, char **argv)) ;
void OsRegexpSubrInitialize OS_P ((OsInterp interp)) ;
    
#endif /* _OS_REGEXP_H_ */
