;; mtst.scm
;; mtst.scm,v 1.1.1.1 1995/02/27 15:14:52 baird Exp
;; See the file COPYRIGHT for licensing conditions.
(require "edit-int")

(xt:set-fallback-resources!
 (vector
  "*allowShellResize: true"
  "*cmdbox.topAttachment: ATTACH_FORM"
  "*cmdbox.leftAttachment: ATTACH_FORM"
  "*cmdbox.rightAttachment: ATTACH_FORM"
  "*cmdbox.orientation: VERTICAL"
  "*cmdbox.packing: pack_column"
  "*butbox.orientation: HORIZONTAL"
  "*butbox.packing: pack_column"
  "*ftext.scrollBarDisplayPolicy: AS_NEEDED"
  "*ftext.topOffset: 100"
  "*ftext.topAttachment: ATTACH_FORM"
  "*ftext.rightAttachment: ATTACH_FORM"
  "*ftext.leftAttachment: ATTACH_FORM"
  "*ftext.bottomAttachment: ATTACH_FORM"
  "*ftext.resizable: true"
  "*display.editMode: multi_line_edit"
  "*display.columns: 70"))

(define f (motif:make-factory (getenv "DISPLAY") "foo" "Foo"))

(define t [f appToplevel])
(define frame [f frame: "frame" parent: t])
[frame marginWidth: 50]
(define form [f form: "cont" parent: frame])


(define cb [f rowColumn: "cmdbox" parent: form])
(define rc [f rowColumn: "butbox" parent: cb])
(define b3 (make-int-editor "speed" rc))
[b3 min: 10]
[b3 max: 100]
[b3 step: 5]
[b3 value: 50]
(define shot [f pushButton: "shot" parent: rc])

(define tt [f toggleButton: "running" parent: rc])
(define msg [f label: "command" parent: cb])
(define ftext [f frame: "ftext" parent: form])
(define text [f scrolledText: "display" parent: ftext])



[t realize]
